diff --git a/src/main/java/net/minecraft/core/net/command/util/ConcatIterable.java b/src/main/java/net/minecraft/core/net/command/util/ConcatIterable.java
new file mode 100644
index 000000000..515e90142
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/util/ConcatIterable.java
@@ -0,0 +1,48 @@
+package net.minecraft.core.net.command.util;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Iterator;
+
+public class ConcatIterable<T> implements Iterable<T> {
+    private final Iterable<T> first;
+    private final Iterable<T> second;
+
+    public ConcatIterable(Iterable<T> first, Iterable<T> second) {
+        this.first = first;
+        this.second = second;
+    }
+
+    @Override
+    public @NotNull Iterator<T> iterator() {
+        return new Iterator<T>() {
+            private final Iterator<T> firstIterator = first.iterator();
+            private final Iterator<T> secondIterator = second.iterator();
+            private boolean firstIteratorActive = true;
+
+            @Override
+            public boolean hasNext() {
+                if (firstIteratorActive) {
+                    if (firstIterator.hasNext()) {
+                        return true;
+                    } else {
+                        firstIteratorActive = false;
+                    }
+                }
+                return secondIterator.hasNext();
+            }
+
+            @Override
+            public T next() {
+                if (firstIteratorActive) {
+                    if (firstIterator.hasNext()) {
+                        return firstIterator.next();
+                    } else {
+                        firstIteratorActive = false;
+                    }
+                }
+                return secondIterator.next();
+            }
+        };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/util/Iterables.java b/src/main/java/net/minecraft/core/net/command/util/Iterables.java
new file mode 100644
index 000000000..daec97807
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/util/Iterables.java
@@ -0,0 +1,25 @@
+package net.minecraft.core.net.command.util;
+
+public abstract class Iterables {
+    public static <T> T getLast(Iterable<? extends T> iterable) {
+        if (iterable instanceof java.util.List) {
+            java.util.List<? extends T> list = (java.util.List<? extends T>) iterable;
+            if (list.isEmpty()) {
+                throw new java.util.NoSuchElementException();
+            }
+            return list.get(list.size() - 1);
+        } else {
+            java.util.Iterator<? extends T> iterator = iterable.iterator();
+            if (!iterator.hasNext()) {
+                throw new java.util.NoSuchElementException();
+            }
+            T last = iterator.next();
+            do {
+                if (!iterator.hasNext()) {
+                    return last;
+                }
+                last = iterator.next();
+            } while (true);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/util/NbtHelper.java b/src/main/java/net/minecraft/core/net/command/util/NbtHelper.java
new file mode 100644
index 000000000..487d2eecd
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/util/NbtHelper.java
@@ -0,0 +1,229 @@
+package net.minecraft.core.net.command.util;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.nbt.*;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.regex.Pattern;
+
+public class NbtHelper {
+    private static final Pattern DOUBLE_PATTERN_NO_SUFFIX = Pattern.compile("[-+]?(?:[0-9]+[.]|[0-9]*[.][0-9]+)(?:e[-+]?[0-9]+)?", Pattern.CASE_INSENSITIVE);
+    private static final Pattern DOUBLE_PATTERN = Pattern.compile("[-+]?(?:[0-9]+[.]?|[0-9]*[.][0-9]+)(?:e[-+]?[0-9]+)?d", Pattern.CASE_INSENSITIVE);
+    private static final Pattern FLOAT_PATTERN = Pattern.compile("[-+]?(?:[0-9]+[.]?|[0-9]*[.][0-9]+)(?:e[-+]?[0-9]+)?f", Pattern.CASE_INSENSITIVE);
+    private static final Pattern BYTE_PATTERN = Pattern.compile("[-+]?(?:0|[1-9][0-9]*)b", Pattern.CASE_INSENSITIVE);
+    private static final Pattern LONG_PATTERN = Pattern.compile("[-+]?(?:0|[1-9][0-9]*)l", Pattern.CASE_INSENSITIVE);
+    private static final Pattern SHORT_PATTERN = Pattern.compile("[-+]?(?:0|[1-9][0-9]*)s", Pattern.CASE_INSENSITIVE);
+    private static final Pattern INT_PATTERN = Pattern.compile("[-+]?(?:0|[1-9][0-9]*)");
+
+    public static CompoundTag parseNbt(String string) throws CommandSyntaxException {
+        return parseNbt(new StringReader(string));
+    }
+
+    public static CompoundTag parseNbt(StringReader reader) throws CommandSyntaxException {
+        CompoundTag tag = new CompoundTag();
+        if (!reader.canRead() || reader.peek() != '{') return tag;
+        int cursor = reader.getCursor();
+        reader.skip();
+        reader.skipWhitespace();
+        while (reader.canRead() && reader.peek() != '}') {
+            String key = reader.readString();
+            reader.skipWhitespace();
+            if (!reader.canRead() || reader.peek() != ':') {
+                reader.setCursor(cursor);
+                throw CommandExceptions.expectedTagKeyValue().createWithContext(reader, key);
+            }
+            reader.skip();
+            reader.skipWhitespace();
+            Tag<?> value = parseTag(reader);
+            tag.put(key, value);
+            reader.skipWhitespace();
+            if (reader.canRead() && reader.peek() == ',') {
+                reader.skip();
+                reader.skipWhitespace();
+                continue;
+            }
+            if (reader.canRead() && reader.peek() == '}') break;
+            throw CommandExceptions.expectedEndOfTag().createWithContext(reader);
+        }
+        if (!reader.canRead()) throw CommandExceptions.expectedEndOfTag().createWithContext(reader);
+        reader.skip();
+        return tag;
+    }
+
+    public static Tag<?> parseTag(StringReader reader) throws CommandSyntaxException {
+        if (!reader.canRead()) throw CommandExceptions.incomplete().create();
+        if (reader.peek() == '{') {
+            return parseNbt(reader);
+        } else if (reader.peek() == '[') {
+            reader.skip();
+            return collection(reader);
+        }
+        return type(reader.readString());
+    }
+
+    private static Tag<?> collection(StringReader reader) throws CommandSyntaxException {
+        reader.skipWhitespace();
+        if (!reader.canRead()) throw CommandExceptions.incomplete().create();
+        if (reader.peek() == 'B') {
+            reader.skip();
+            reader.skipWhitespace();
+            if (!reader.canRead()) throw CommandExceptions.incomplete().create();
+            if (reader.peek() == ']') return new ByteArrayTag();
+            else if (reader.peek() == ';') {
+                reader.skip();
+                List<Byte> bytes = new ArrayList<>();
+                while (reader.canRead() && reader.peek() != ']') {
+                    reader.skipWhitespace();
+                    String byteAsString = reader.readString();
+                    if (!BYTE_PATTERN.matcher(byteAsString).matches()) throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.readerExpectedSymbol().create("byte");
+                    byte parsedByte = Byte.parseByte(byteAsString.substring(0, byteAsString.length() - 1));
+                    bytes.add(parsedByte);
+                    reader.skipWhitespace();
+                    if (!reader.canRead() || reader.peek() != ',') break;
+                    reader.skip();
+                }
+                reader.skipWhitespace();
+                if (reader.canRead() && reader.peek() == ']') {
+                    reader.skip();
+                    return new ByteArrayTag(byteListToArray(bytes));
+                }
+                throw CommandExceptions.expectedEndOfTag().create();
+            }
+        } else if (reader.peek() == 'S') {
+            reader.skip();
+            reader.skipWhitespace();
+            if (!reader.canRead()) throw CommandExceptions.incomplete().create();
+            if (reader.peek() == ']') {
+                reader.skip();
+                return new ShortArrayTag();
+            }
+            else if (reader.peek() == ';') {
+                reader.skip();
+                List<Short> shorts = new ArrayList<>();
+                while (reader.canRead() && reader.peek() != ']') {
+                    reader.skipWhitespace();
+                    String shortAsString = reader.readString();
+                    if (!SHORT_PATTERN.matcher(shortAsString).matches()) throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.readerExpectedSymbol().create("short");
+                    short parsedShort = Short.parseShort(shortAsString.substring(0, shortAsString.length() - 1));
+                    shorts.add(parsedShort);
+                    reader.skipWhitespace();
+                    if (!reader.canRead() || reader.peek() != ',') break;
+                    reader.skip();
+                }
+                reader.skipWhitespace();
+
+                if (reader.canRead() && reader.peek() == ']') {
+                    reader.skip();
+                    return new ShortArrayTag(shortListToArray(shorts));
+                }
+                else throw CommandExceptions.expectedEndOfTag().create();
+            }
+        } else if (reader.peek() == 'D') {
+            reader.skip();
+            reader.skipWhitespace();
+            if (!reader.canRead()) throw CommandExceptions.incomplete().create();
+            if (reader.peek() == ']') {
+                reader.skip();
+                return new DoubleArrayTag();
+            }
+            else if (reader.peek() == ';') {
+                reader.skip();
+                List<Double> doubles = new ArrayList<>();
+                while (reader.canRead() && reader.peek() != ']') {
+                    reader.skipWhitespace();
+                    String doubleAsString = reader.readString();
+                    double parsedDouble;
+                    if (DOUBLE_PATTERN.matcher(doubleAsString).matches()) {
+                        parsedDouble = Double.parseDouble(doubleAsString.substring(0, doubleAsString.length() - 1));
+                    } else if (DOUBLE_PATTERN_NO_SUFFIX.matcher(doubleAsString).matches()) {
+                        parsedDouble = Double.parseDouble(doubleAsString);
+                    }
+                    else throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.readerExpectedDouble().create();
+                    doubles.add(parsedDouble);
+                    reader.skipWhitespace();
+                    if (!reader.canRead() || reader.peek() != ',') break;
+                    reader.skip();
+                }
+                reader.skipWhitespace();
+                if (reader.canRead() && reader.peek() == ']') {
+                    reader.skip();
+                    return new DoubleArrayTag(doubles.stream().mapToDouble(Double::doubleValue).toArray());
+                }
+                else throw CommandExceptions.expectedEndOfTag().create();
+            }
+        } else {
+            List<Tag<?>> tags = new ArrayList<>();
+            while (reader.canRead() && reader.peek() != ']') {
+                reader.skipWhitespace();
+                tags.add(parseTag(reader));
+                reader.skipWhitespace();
+                if (!reader.canRead() || reader.peek() != ',') break;
+                reader.skip();
+            }
+            reader.skipWhitespace();
+            if (reader.canRead() && reader.peek() == ']') {
+                reader.skip();
+                return new ListTag(tags);
+            }
+            else throw CommandExceptions.expectedEndOfTag().create();
+        }
+        throw CommandExceptions.incomplete().create();
+    }
+
+    private static short[] shortListToArray(List<Short> shorts) {
+        short[] arr = new short[shorts.size()];
+
+        for (int i = 0; i < shorts.size(); i++) {
+            arr[i] = shorts.get(i);
+        }
+
+        return arr;
+    }
+
+    private static byte[] byteListToArray(List<Byte> bytes) {
+        byte[] arr = new byte[bytes.size()];
+
+        for (int i = 0; i < bytes.size(); i++) {
+            arr[i] = bytes.get(i);
+        }
+
+        return arr;
+    }
+
+    private static Tag<?> type(String string) {
+        try {
+            if ("true".equalsIgnoreCase(string)) {
+                return new ByteTag((byte) 1);
+            }
+            if ("false".equalsIgnoreCase(string)) {
+                return new ByteTag((byte) 0);
+            }
+            if (BYTE_PATTERN.matcher(string).matches()) {
+                return new ByteTag(Byte.parseByte(string.substring(0, string.length() - 1)));
+            }
+            if (SHORT_PATTERN.matcher(string).matches()) {
+                return new ShortTag(Short.parseShort(string.substring(0, string.length() - 1)));
+            }
+            if (INT_PATTERN.matcher(string).matches()) {
+                return new IntTag(Integer.parseInt(string));
+            }
+            if (LONG_PATTERN.matcher(string).matches()) {
+                return new LongTag(Long.parseLong(string.substring(0, string.length() - 1)));
+            }
+            if (FLOAT_PATTERN.matcher(string).matches()) {
+                return new FloatTag(Float.parseFloat(string.substring(0, string.length() - 1)));
+            }
+            if (DOUBLE_PATTERN.matcher(string).matches()) {
+                return new DoubleTag(Double.parseDouble(string.substring(0, string.length() - 1)));
+            }
+            if (DOUBLE_PATTERN_NO_SUFFIX.matcher(string).matches()) {
+                return new DoubleTag(Double.parseDouble(string));
+            }
+        } catch (NumberFormatException ignored) {
+        }
+        return new StringTag(string);
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index 842280c2c..cffa6be0f 100644
--- a/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -372,4 +372,12 @@ public abstract class PacketHandler
     public void handleCustomPayload(CustomPayloadPacket packet) {
     	handleInvalidPacket(packet);
     }
+
+    public void handleCommandManagerPacket(CommandManagerPacket packet) {
+        handleInvalidPacket(packet);
+    }
+
+    public void handleRequestCommandManagerPacket(RequestCommandManagerPacket packet) {
+        handleInvalidPacket(packet);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/CommandManagerPacket.java b/src/main/java/net/minecraft/core/net/packet/CommandManagerPacket.java
new file mode 100644
index 000000000..5046af2d5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/CommandManagerPacket.java
@@ -0,0 +1,189 @@
+package net.minecraft.core.net.packet;
+
+import com.google.gson.JsonArray;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParser;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.ParseResults;
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.context.CommandContextBuilder;
+import com.mojang.brigadier.context.ParsedArgument;
+import com.mojang.brigadier.context.SuggestionContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.suggestion.Suggestion;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import com.mojang.brigadier.tree.CommandNode;
+import com.mojang.brigadier.tree.LiteralCommandNode;
+import net.minecraft.core.net.command.CommandManagerPacketKeys;
+import net.minecraft.core.net.command.CommandManager;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.handler.PacketHandler;
+import org.jetbrains.annotations.NotNull;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+import java.util.*;
+import java.util.concurrent.CompletableFuture;
+
+public class CommandManagerPacket extends Packet {
+    private CommandDispatcher<CommandSource> dispatcher;
+    private CommandSource source;
+    private String text;
+    private int cursor;
+
+    public JsonObject suggestions;
+
+    public CommandManagerPacket(CommandDispatcher<CommandSource> dispatcher, CommandSource source, String text, int cursor) {
+        this.dispatcher = dispatcher;
+        this.source = source;
+        this.text = text;
+        this.cursor = cursor;
+    }
+
+    public CommandManagerPacket() {
+    }
+
+    @Override
+    public void read(DataInputStream dis) throws IOException {
+        String str = dis.readUTF();
+        this.suggestions = JsonParser.parseString(str).getAsJsonObject();
+    }
+
+    @Override
+    public void write(DataOutputStream dos) throws IOException {
+        String str = getDispatcherSuggestions(this.dispatcher, this.source, this.text, this.cursor).toString();
+        dos.writeUTF(str);
+    }
+
+    private static JsonObject getDispatcherSuggestions(CommandDispatcher<CommandSource> dispatcher, CommandSource source, String text, int cursor) {
+        final JsonObject object = new JsonObject();
+        final JsonArray suggestions = new JsonArray();
+        final JsonArray exceptions = new JsonArray();
+        final JsonArray usage = new JsonArray();
+        StringReader reader = new StringReader(text);
+        if (reader.canRead() && reader.peek() == '/') reader.skip();
+        ParseResults<CommandSource> parseResults = dispatcher.parse(reader, source);
+        JsonObject readerJson = new JsonObject();
+        readerJson.addProperty(CommandManagerPacketKeys.READER_CAN_READ, parseResults.getReader().canRead());
+        int readerCursor = Math.max(parseResults.getReader().getCursor(), 0);
+        readerJson.addProperty(CommandManagerPacketKeys.READER_CURSOR, readerCursor);
+        int remainingTextLength = Math.min(readerCursor + parseResults.getReader().getRemainingLength(), text.length());
+        readerJson.addProperty(CommandManagerPacketKeys.READER_REMAINING_TEXT_LENGTH, remainingTextLength);
+        readerJson.addProperty(CommandManagerPacketKeys.READER_STRING, parseResults.getReader().getString());
+        object.add(CommandManagerPacketKeys.READER, readerJson);
+        object.addProperty(CommandManagerPacketKeys.SUGGESTION_CONTEXT_START_POS, parseResults.getContext().findSuggestionContext(cursor).startPos);
+
+        CompletableFuture<Suggestions> pendingSuggestions = getCompletionSuggestions(parseResults, cursor, source);
+        pendingSuggestions.thenRun(() -> {
+            if (pendingSuggestions.isDone()) {
+                for (Suggestion suggestion : pendingSuggestions.join().getList()) {
+                    JsonObject suggestionJson = new JsonObject();
+                    suggestionJson.addProperty(CommandManagerPacketKeys.VALUE, suggestion.getText());
+                    JsonObject range = new JsonObject();
+                    range.addProperty(CommandManagerPacketKeys.RANGE_START, suggestion.getRange().getStart());
+                    range.addProperty(CommandManagerPacketKeys.RANGE_END, suggestion.getRange().getEnd());
+                    suggestionJson.add(CommandManagerPacketKeys.RANGE, range);
+                    if (suggestion.getTooltip() != null)
+                        suggestionJson.addProperty(CommandManagerPacketKeys.TOOLTIP, suggestion.getTooltip().getString());
+                    suggestions.add(suggestionJson);
+                }
+            }
+        });
+        CommandSyntaxException parseException = CommandManager.getParseException(parseResults);
+        if (!parseResults.getExceptions().isEmpty()) {
+            for (CommandSyntaxException entry : parseResults.getExceptions().values()) {
+                JsonObject exceptionJson = new JsonObject();
+                exceptionJson.addProperty(CommandManagerPacketKeys.VALUE, entry.getMessage());
+                exceptions.add(exceptionJson);
+            }
+        } else if (parseException != null) {
+            JsonObject exceptionJson = new JsonObject();
+            exceptionJson.addProperty(CommandManagerPacketKeys.VALUE, parseException.getMessage());
+            exceptions.add(exceptionJson);
+        } else if (parseResults.getContext().getRootNode() != null && parseResults.getContext().getRange().getStart() <= cursor) {
+            JsonObject commandUsage = new JsonObject();
+            for (Map.Entry<CommandNode<CommandSource>, String> entry : dispatcher.getSmartUsage(parseResults.getContext().findSuggestionContext(cursor).parent, source).entrySet()) {
+                if (entry.getKey() instanceof LiteralCommandNode) continue;
+                commandUsage.addProperty(CommandManagerPacketKeys.VALUE, entry.getValue());
+                usage.add(commandUsage);
+            }
+        }
+
+        JsonObject lastChild = getLastChild(parseResults);
+        object.add(CommandManagerPacketKeys.LAST_CHILD, lastChild);
+        object.add(CommandManagerPacketKeys.SUGGESTIONS, suggestions);
+        object.add(CommandManagerPacketKeys.EXCEPTIONS, exceptions);
+        object.add(CommandManagerPacketKeys.USAGE, usage);
+        return object;
+    }
+
+    private static CompletableFuture<Suggestions> getCompletionSuggestions(final ParseResults<CommandSource> parse, int cursor, CommandSource source) {
+        final CommandContextBuilder<CommandSource> context = parse.getContext();
+
+        final SuggestionContext<CommandSource> nodeBeforeCursor = context.findSuggestionContext(cursor);
+        final CommandNode<CommandSource> parent = nodeBeforeCursor.parent;
+        if (parent == null) return Suggestions.empty();
+        final int start = Math.min(nodeBeforeCursor.startPos, cursor);
+
+        final String fullInput = parse.getReader().getString();
+        final String truncatedInput = fullInput.substring(0, cursor);
+        final String truncatedInputLowerCase = truncatedInput.toLowerCase(Locale.ROOT);
+        List<CompletableFuture<Suggestions>> futuresList = new ArrayList<>();
+        int i = 0;
+        for (final CommandNode<CommandSource> node : parent.getChildren()) {
+            if (!node.canUse(source)) continue;
+            CompletableFuture<Suggestions> future = Suggestions.empty();
+            try {
+                future = node.listSuggestions(context.build(truncatedInput), new SuggestionsBuilder(truncatedInput, truncatedInputLowerCase, start));
+            } catch (final CommandSyntaxException ignored) {
+            }
+            futuresList.add(future);
+            i++;
+        }
+
+        @SuppressWarnings("unchecked") final CompletableFuture<Suggestions>[] futures = new CompletableFuture[i];
+        for (int j = 0; j < futures.length; j++) {
+            futures[j] = futuresList.get(j);
+        }
+
+        final CompletableFuture<Suggestions> result = new CompletableFuture<>();
+        CompletableFuture.allOf(futures).thenRun(() -> {
+            final List<Suggestions> suggestions = new ArrayList<>();
+            for (final CompletableFuture<Suggestions> future : futuresList) {
+                suggestions.add(future.join());
+            }
+            result.complete(Suggestions.merge(fullInput, suggestions));
+        });
+
+        return result;
+    }
+
+    @NotNull
+    private static JsonObject getLastChild(ParseResults<CommandSource> parseResults) {
+        JsonObject lastChild = new JsonObject();
+        CommandContextBuilder<CommandSource> builder = parseResults.getContext().getLastChild();
+        JsonArray arguments = new JsonArray();
+        for (ParsedArgument<CommandSource, ?> parsedArgument : builder.getArguments().values()) {
+            JsonObject argument = new JsonObject();
+            JsonObject range = new JsonObject();
+            range.addProperty(CommandManagerPacketKeys.RANGE_START, parsedArgument.getRange().getStart());
+            range.addProperty(CommandManagerPacketKeys.RANGE_END, parsedArgument.getRange().getEnd());
+            argument.add(CommandManagerPacketKeys.RANGE, range);
+            arguments.add(argument);
+        }
+        lastChild.add(CommandManagerPacketKeys.ARGUMENTS, arguments);
+        return lastChild;
+    }
+
+    @Override
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleCommandManagerPacket(this);
+    }
+
+    @Override
+    public int getEstimatedSize() {
+        return 1;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet.java b/src/main/java/net/minecraft/core/net/packet/Packet.java
index f11ea80bd..f771af942 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -310,6 +310,8 @@ public abstract class Packet
         addMapping(106, true, true, ContainerAckPacket.class);
         addMapping(107, false, true, UpdateCreativeInventoryPacket.class);
         addMapping(108, false, true, SetHotbarOffsetPacket.class);
+        addMapping(120, true, false, CommandManagerPacket.class);
+        addMapping(121, false, true, RequestCommandManagerPacket.class);
         addMapping(130, false, true, SignUpdatePacket.class);
         addMapping(131, true, false, MapDataPacket.class);
         addMapping(132, true, true, SetMobSpawnerPacket.class);
diff --git a/src/main/java/net/minecraft/core/net/packet/RequestCommandManagerPacket.java b/src/main/java/net/minecraft/core/net/packet/RequestCommandManagerPacket.java
new file mode 100644
index 000000000..d7b9e4f2d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/RequestCommandManagerPacket.java
@@ -0,0 +1,46 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class RequestCommandManagerPacket extends Packet {
+    public String username;
+    public String text;
+    public int cursor;
+
+    public RequestCommandManagerPacket(String username, String text, int cursor) {
+        this.username = username;
+        this.text = text;
+        this.cursor = cursor;
+    }
+
+    public RequestCommandManagerPacket() {
+    }
+
+    @Override
+    public void read(DataInputStream dis) throws IOException {
+        this.username = dis.readUTF();
+        this.text = dis.readUTF();
+        this.cursor = dis.readInt();
+    }
+
+    @Override
+    public void write(DataOutputStream dos) throws IOException {
+        dos.writeUTF(this.username);
+        dos.writeUTF(this.text);
+        dos.writeInt(this.cursor);
+    }
+
+    @Override
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleRequestCommandManagerPacket(this);
+    }
+
+    @Override
+    public int getEstimatedSize() {
+        return 10;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index a0c38fa64..4412efabb 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -16,7 +16,7 @@ import java.util.UUID;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 
-import net.minecraft.client.option.enums.Difficulty;
+import net.minecraft.core.enums.Difficulty;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -27,6 +27,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.block.Block;
@@ -135,6 +136,8 @@ public class World implements WorldSource {
 
     public final WeatherManager weatherManager;
 
+    private CommandManager commandManager;
+
     //Usually called when a world is loaded or generated (Singleplayer & Server)
     public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType, SpawnerMobs.SpawnerConfig spawningConfig)
     {
@@ -221,6 +224,9 @@ public class World implements WorldSource {
             getInitialSpawnLocation();
         }
         updateSkyBrightness();
+
+        this.commandManager = new CommandManager(isServer);
+        this.commandManager.init();
     }
 
     //Usually called when going through portals
@@ -263,6 +269,8 @@ public class World implements WorldSource {
 
         auroraProvider = new AuroraProvider(this, this.getRandomSeed());
 
+        this.commandManager = new CommandManager(isServer);
+        this.commandManager.init();
     }
 
     //Usually called when joining a server
@@ -285,7 +293,11 @@ public class World implements WorldSource {
         biomeProvider = this.worldType.createBiomeProvider(this);
 
         spawningConfig = new SpawnerMobs.SpawnerConfig();
+
+        this.commandManager = new CommandManager(isServer);
+        this.commandManager.init();
     }
+
     // Used for the model viewer
     public World(){
         this.dimension = Dimension.overworld;
@@ -320,6 +332,10 @@ public class World implements WorldSource {
         return biomeProvider;
     }
 
+    public CommandManager getCommandManager() {
+        return commandManager;
+    }
+
     protected IChunkProvider createChunkProvider()
     {
         IChunkLoader chunkLoader = saveHandler.getChunkLoader(dimension);
diff --git a/src/main/java/net/minecraft/core/world/save/LevelData.java b/src/main/java/net/minecraft/core/world/save/LevelData.java
index 49f65145d..3f1f53b8f 100644
--- a/src/main/java/net/minecraft/core/world/save/LevelData.java
+++ b/src/main/java/net/minecraft/core/world/save/LevelData.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.save;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.client.option.enums.Difficulty;
+import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.CompoundTag;
